---
title: Event.cancelable
slug: Web/API/Event/cancelable
tags:
  - API
  - DOM
  - DOM Reference
  - Event
  - Property
  - Read-only
  - Reference
---
<div>{{ ApiRef("DOM") }}</div>

<p><span class="seoSummary">The <strong><dfn><code>cancelable</code></dfn></strong> read-only property of the {{domxref("Event")}} interface indicates whether the event can be canceled, and therefore prevented as if the event never happened.</span> If the event is <em>not</em> cancelable, then its <code>cancelable</code> property will be <code>false</code> and the event listener cannot stop the event from occurring.</p>

<p>Event listeners that handle multiple kinds of events may want to check <code>cancelable</code> before invoking their {{domxref("event.preventDefault", "preventDefault()")}} methods.</p>

<p>Most browser-native events that can be canceled are the ones that result from the user interacting with the page. Canceling the {{domxref("Element/click_event", "click")}}, {{domxref("Document/scroll_event", "scroll")}}, or {{domxref("Window/beforeunload_event", "beforeunload")}} events would prevent the user from clicking on something, scrolling the page, or navigating away from the page, respectively.</p>

<p><a href="/en-US/docs/Web/API/Event/Event">Custom events</a> created by other JavaScript code control if they can be canceled when they are created.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>bool</var> = <em>event</em>.cancelable;
</pre>

<h3 id="Value">Value</h3>

<p>The result is a {{domxref("Boolean")}}, which is <code>true</code> if the event can be canceled.</p>

<h2 id="Example">Example</h2>

<p>For example, browser vendors are proposing that the {{domxref("Document/wheel_event", "wheel")}} event can only be canceled <a href="https://github.com/WICG/interventions/issues/33" rel="external">the first time the listener is called</a> — any following <code>wheel</code> events cannot be canceled.</p>

<pre class="brush:js">function preventScrollWheel(event) {
  if (typeof event.cancelable !== 'boolean' || event.cancelable) {
    // The event can be canceled, so we do so.
    event.preventDefault();
  } else {
    // The event cannot be canceled, so it is not safe
    // to call preventDefault() on it.
    console.warn(`The following event couldn't be canceled:`);
    console.dir(event);
  }
}

document.addEventListener('wheel', preventScrollWheel);
</pre>

<h2 id="Notes">Notes</h2>

<p>Whether an event can be canceled or not is something that's determined when that event is initialized.</p>

<p>To cancel an event, call the {{domxref("event.preventDefault", "preventDefault()")}} method on the event. This keeps the implementation from executing the default action that is associated with the event.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-event-cancelable', 'Event.cancelable')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Events', '#Events-Event-canCancel', 'Event.cancelable')}}</td>
   <td>{{ Spec2('DOM2 Events') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Event.cancelable")}}</p>
